#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Link Expiry Tool
# DIZ: Delete links older than a specified date.
# GRAPHIC: ic_spam3.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use Time::Local;  
#use psfp;
&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
# not below if's - else bypassed...
print "Content-type: text/html\n\n"; 

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "start_exp") {&start_exp;}



sub start_exp
{

$from_day = $q->param('from_day');
$from_month = $q->param('from_month'); $from_month = $from_month - 1;
$from_year = $q->param('from_year');

eval { $time = timelocal(0,0,0, $from_day,$from_month,$from_year);
 		  }; #warn $@ if $@;
 	if ($@ ne "") 
			{
 			$problem = "The date that you specified is not a valid date. <br></b>Reason:</b> $@"; 
 			}

if ($problem ne ""){acs::problem_popup($problem);}


$del_prem = $q->param('del_prem');
$del_stand = $q->param('del_stand');

if (($del_prem eq "") and ($del_stand eq "")) {acs::problem_popup("You have not chosen to remove any standard or premium links.");}

#if ($q->param('fct') eq "expiry_email") {&send_email_exp;}


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

if (($del_prem eq "Y") and ($del_stand eq "Y"))
	{
	$sql = "DELETE FROM links WHERE ((urldate < '$time') AND (urldate IS NOT NULL) AND (urldate != '0')) ";
	}
	elsif (($del_prem eq "Y") and ($del_stand eq ""))
	{
	$sql = "DELETE FROM links WHERE ((urldate < '$time') AND (urldate IS NOT NULL) AND (urldate != '0') AND (premium > 0)) ";
	}
	elsif (($del_prem eq "") and ($del_stand eq "Y"))
	{
	$sql = "DELETE FROM links WHERE ((urldate < '$time') AND (urldate IS NOT NULL) AND (urldate != '0') AND ((premium IS NULL) OR (premium < '1'))) ";
	}

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From $sql";}
$rows = $sth->rows();

$sth->finish;
$dbh->disconnect; 


$hbox = acs::get_heading_box("$web_url/ic_spam3.gif", "Links/Listings Removed", qq[<p>$rows Listings/Links older than <strong>$from_year-$from_month-$from_day</strong>
removed. <a href="$admin_url/p_expire.cgi">Click here to continue.</a></p>

<p>Note that when you delete links that the link numbers needs to be updated/recounted.
The link numbers are indicated next to categories. <a
href="$admin_url/recountlnks.cgi?fct=count" target="_blank">Click here to recount the
links.</a></p>]); 


print qq[<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

];

}




sub start
{

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
$year = $year + 1900;

$start_day[$mday -1] = "selected";

$start_month[$mon] = "selected";


if ($year eq "2007") { $start_year[0] = "selected"; }
if ($year eq "2008") { $start_year[1] = "selected"; }
if ($year eq "2009") { $start_year[2] = "selected"; }
if ($year eq "2010") { $start_year[3] = "selected"; }
if ($year eq "2011") { $start_year[4] = "selected"; }
if ($year eq "2012") { $start_year[5] = "selected"; }
if ($year eq "2013") { $start_year[6] = "selected"; }
if ($year eq "2014") { $start_year[7] = "selected"; }
if ($year eq "2015") { $start_year[8] = "selected"; }
if ($year eq "2016") { $start_year[9] = "selected"; }



$hbox = acs::get_heading_box("$web_url/ic_spam3.gif", "Link Expiry Tool", qq[This plugin will delete listings/links older than a specified date.]); 

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox



<form method="POST" action="$admin_url/p_expire.cgi">
  <input type="hidden" name="fct" value="start_exp"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DADADA">
    <tr>
      <td height="35" colspan="2" background="$web_url/bar6.gif" bgcolor="#F4F4F4" class="normaltext"><strong>Choose
      a date to delete listings/links that is older than the date chosen. </strong></td>
    </tr>
    <tr>
      <td width="250" bgcolor="#FFFFFF" class="normaltext">Delete listings/links older than: </td>
      <td width="954" bgcolor="#FFFFFF" class="normaltext"><select name="from_day" size="1">
        <option $start_day[0] value="1" selected> 1 </option>
        <option $start_day[1] value="2"> 2 </option>
        <option $start_day[2] value="3"> 3 </option>
        <option $start_day[3] value="4"> 4 </option>
        <option $start_day[4] value="5"> 5 </option>
        <option $start_day[5] value="6"> 6 </option>
        <option $start_day[6] value="7"> 7 </option>
        <option $start_day[7] value="8"> 8 </option>
        <option $start_day[8] value="9"> 9 </option>
        <option $start_day[9] value="10"> 10 </option>
        <option $start_day[10] value="11"> 11 </option>
        <option $start_day[11] value="12"> 12 </option>
        <option $start_day[12] value="13"> 13 </option>
        <option $start_day[13] value="14"> 14 </option>
        <option $start_day[14] value="15"> 15 </option>
        <option $start_day[15] value="16"> 16 </option>
        <option $start_day[16] value="17"> 17 </option>
        <option $start_day[17] value="18"> 18 </option>
        <option $start_day[18] value="19"> 19 </option>
        <option $start_day[19] value="20"> 20 </option>
        <option $start_day[20] value="21"> 21 </option>
        <option $start_day[21] value="22"> 22 </option>
        <option $start_day[22] value="23"> 23 </option>
        <option $start_day[23] value="24"> 24 </option>
        <option $start_day[24] value="25"> 25 </option>
        <option $start_day[25] value="26"> 26 </option>
        <option $start_day[26] value="27"> 27 </option>
        <option $start_day[27] value="28"> 28 </option>
        <option $start_day[28] value="29"> 29 </option>
        <option $start_day[29] value="30"> 30 </option>
        <option $start_day[30] value="31"> 31 </option>
      </select> <select name="from_month" size="1">
        <option $start_month[0] value="1"> January </option>
        <option $start_month[1] value="2"> February </option>
        <option $start_month[2] value="3"> March </option>
        <option $start_month[3] value="4"> April </option>
        <option $start_month[4] value="5"> May </option>
        <option $start_month[5] value="6"> June </option>
        <option $start_month[6] value="7"> July </option>
        <option $start_month[7] value="8"> August </option>
        <option $start_month[8] value="9"> September </option>
        <option $start_month[9] value="10"> October </option>
        <option $start_month[10] value="11"> November </option>
        <option $start_month[11] value="12"> December </option>
      </select> <select name="from_year" size="1">
        <option value="2000"> 2000 </option>
        <option value="2001"> 2001 </option>
        <option value="2002"> 2002 </option>
        <option value="2003"> 2003 </option>
        <option value="2004"> 2004 </option>
        <option value="2005"> 2005 </option>
        <option value="2006"> 2006 </option>
        <option $start_year[0] value="2007"> 2007 </option>
        <option $start_year[1] value="2008"> 2008 </option>
        <option $start_year[2] value="2009"> 2009 </option>
        <option $start_year[3] value="2010"> 2010 </option>
        <option $start_year[4] value="2011"> 2011 </option>
        <option $start_year[5] value="2012"> 2012 </option>
        <option $start_year[6] value="2013"> 2013 </option>
        <option $start_year[7] value="2014"> 2014 </option>
        <option $start_year[8] value="2015"> 2015 </option>
        <option $start_year[9] value="2016"> 2016 </option>
      </select> </td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="del_prem"
      value="Y" checked> Delete Premium listings/links. (If not checked then older premium
      listings won't be deleted) </td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="del_stand"
      value="Y" checked> Delete Standard listings/links. </td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="Submit"
      name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>




</body>
</html>
];


}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

